<?php

require_once '../../../../init.php';
// Required files
require_once MAX_PATH.'/lib/OA/Admin/Option.php';
require_once MAX_PATH.'/lib/OA/Admin/Settings.php';
require_once MAX_PATH.'/lib/OA/Permission.php';
require_once MAX_PATH.'/lib/max/Plugin/Translation.php';
require_once MAX_PATH.'/lib/OX/Plugin/Component.php';
require_once MAX_PATH.'/www/admin/config.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
//Function to get the domain name
function url($url)
{
    $pu = parse_url($url);
    return $pu["scheme"]."://".$pu["host"];
}
// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);
$oTranslation = new OX_Translation();
$agencyId = 1; //OA_Permission::getAgencyId();
// Create a new option object for displaying the setting's page's HTML form
$oOptions = new OA_Admin_Option('account-settings-feedlist');
$prefSection = "XmlFeed Network";
$aErrormessage = array();

$setPref = $oOptions->getSettingsPreferences($prefSection);
$title = $setPref[$prefSection]['name'];
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel("Xmlfeed Network");
phpAds_PageHeader('account-settings-feedlist', $oHeaderModel);

if (isset($_POST['submitok']) && $_POST['submitok'] == 'true')
{
    $translation = new OX_Translation();
    $base_url = explode("?", $_POST['reurl']);
    $_POST['re_url'] = url($_POST['reurl']);
    $_POST['res_url'] = $base_url[0];
    $country = $_POST['country'];
    $category = $_POST['category'];
    $date = date('Y-m-d');
    $time = date('Y-m-d H:i:s');
    $last_insert_advid = "";
    $last_insert_campid = "";
    $last_insert_bannerid = "";
    
    $all_banner_id = array();
    
    
    $map_pub=implode(",",$_POST['publisher']);
	
// add new feed network
    OA_Dal_Delivery_query("INSERT INTO djax_feed_network(
								feed_network_agency_id,
								feed_network_name,
								publisher_id,
								source_id,
								auth_key,
								feed_network_ads_url,
								feed_network_report_url,
								feed_network_ads_base_url,
								feed_network_report_base_url,
								date_added,
								status,
								is_valid,
								is_deleted,
								is_white_label,
								shop_country_id,
								shop_category_id,
								map_publisherid
								)
							 VALUES(
								'".$agencyId."',
								'".$_POST['netname']."',
								'".$_POST['npid']."',
								'".$_POST['nsid']."',
								'".$_POST['nakey']."',
								'".$_POST['resurl']."',
								'".$_POST['reurl']."',
								'".$_POST['res_url']."',
								'".$_POST['re_url']."',
								'".$date."',
								0,0,0,0,
								'".$country."',
								'".$category."',
								'".$map_pub."'
									)") or die("insert");
    $id = OA_Dal_Delivery_insertId();

	$agency_query = OA_Dal_Delivery_query("SELECT * FROM {$table_prefix}agency WHERE status=0");
	while($cdata_agency = OA_Dal_Delivery_fetchAssoc($agency_query))
	{
		$agencyId = $cdata_agency['agencyid'];
		
		//Add Account
		OA_Dal_Delivery_query("INSERT INTO {$table_prefix}accounts(
									account_type,
									account_name
									)
								 VALUES(
									'ADVERTISER',
									'".$_POST['netname']."_advertiser'
									)") or die("error");
		$last_insert_accountid = OA_Dal_Delivery_insertId();
		
		//For create advertiser
		$email = $_POST['netname'].'@xmlfeed.com';
		OA_Dal_Delivery_query("INSERT INTO {$table_prefix}clients(
									agencyid,
									clientname,
									contact,
									email,
									report,
									reportinterval,
									reportlastdate,
									reportdeactivate,
									comments,
									updated,
									account_id,
									advertiser_limitation,
									type)
								 VALUES(
									".$agencyId.",
									'".$_POST['netname']."_advertiser',
									'xmlfeed user',
									'".$email."',
									'f',
									'7',
									'',
									'',
									'',
									'".$time."',
									'".$last_insert_accountid."',
									'0',
									'0'
									)") or die("");
		$last_insert_advid = OA_Dal_Delivery_insertId();
		
		   //create campaigns
			if ($last_insert_advid)
			{
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}campaigns(campaignname,clientid,views,clicks,conversions,
										priority,weight,target_impression,target_click,
										target_conversion,anonymous,companion,comments,
										revenue,revenue_type,
										updated,block,capping,session_capping,
										status,hosted_views,hosted_clicks,viewwindow,
										clickwindow,ecpm,min_impressions,ecpm_enabled,
										activate_time,type,show_capped_no_cookie
										)
									 VALUES(
										'".$_POST['netname']."_campaign','".$last_insert_advid."','-1','-1','-1','-1','1',
										'0',
										'0',
										'0',
										'f',
										'0',
										'',
										'','2','".$time."','0','0','0','0','0','0','0','0','','100','0','".$time."','0','0'
										)") or die("");
				$last_insert_campid = OA_Dal_Delivery_insertId();
			}
			 
			//for banner creation
			if ($last_insert_campid)
			{
				$last_insert_bannerid=[];
				$contenttype = 'jpeg';
				$storagetype = 'web';
				$desc = "".$_POST['netname']." native ad served in campaigns";
				$bannertype = "bannerTypeText:oxText:genericText";
				$native_type = "";
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','txt','0','txt','','','',
										 '',
										 '0',
										 '0',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 'https://www.google.com/','','text_banner','".$_POST['netname']." text ad served in campaigns','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','".$bannertype."','','0','1'
										 )") or die('');
							$last_insert_bannerid[] = OA_Dal_Delivery_insertId();

				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','".$contenttype."','0','".$storagetype."','ef180efc30bd1d5e19837f8a46d687f5.jpg','','',
										 '',
										 '300',
										 '250',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 '','','','".$desc."','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','','','0','1'
										 )") or die('');
				$last_insert_bannerid[] = OA_Dal_Delivery_insertId();
				$last_insert_bannerid=implode(",",$last_insert_bannerid);
			}
			
			// insert all id's in the djax_all_network_feed table
			OA_Dal_Delivery_query("INSERT INTO djax_all_network_feed(
								networkid,
								agencyid,
								clientid,
								campaignid,
								bannerid
								)
							 VALUES(
								'".$id."',
								'".$agencyId."',
								'".$last_insert_advid."',
								'".$last_insert_campid."',
								'".$last_insert_bannerid."'
									)") or die("insertnew");
				array_push($all_banner_id,$last_insert_bannerid);
	}
    
    $c_bannerid = implode(',',$all_banner_id);
    
    if (is_array($_POST['publisher'])) {
        // Convert the array to a string, if that's appropriate for your case
        // You might join the array elements with a delimiter like ','
        $publisherString = implode(',', $_POST['publisher']);
    } else {
        // Ensure it's a string, or handle it if it's not
        $publisherString = $_POST['publisher'];
    }
    $publisher_ID = explode(",", $publisherString);
	foreach($publisher_ID as $pid)
	{
	
	$query_sel_zone = OA_Dal_Delivery_query("SELECT zoneid,delivery FROM ".$table_prefix."zones where affiliateid=".$pid);
	$zone_count=OA_Dal_Delivery_numRows($query_sel_zone);
	if($zone_count>0)
	{
		while ($arow_sel_zone = OA_Dal_Delivery_fetchAssoc($query_sel_zone))
		{
			
			$get_web_agency_qry = OA_Dal_Delivery_query("SELECT agencyid FROM ".$table_prefix."affiliates where affiliateid=".$pid);
			$get_web_agency = OA_Dal_Delivery_fetchAssoc($get_web_agency_qry);
			
			//echo "<pre>";print_r($get_web_agency);echo "--------";
			
			$get_agency_ban_qry = OA_Dal_Delivery_query("SELECT bannerid FROM djax_all_network_feed where networkid=".$id." and agencyid =".$get_web_agency['agencyid']);
			$get_agency_ban = OA_Dal_Delivery_fetchAssoc($get_agency_ban_qry);
						
			$last_insert_bannerid_exp=explode(",",$get_agency_ban['bannerid']);
			
			//echo "<pre>";print_r($last_insert_bannerid_exp);echo "*********";

			foreach($last_insert_bannerid_exp as $bannerid_get)
			{
				
				$banner_as_storage1 = OA_Dal_Delivery_query("SELECT storagetype from {$table_prefix}banners where  bannerid=".$bannerid_get);
				$banner_as_storage = OA_Dal_Delivery_fetchAssoc($banner_as_storage1);
				$query_select_zones_ass = OA_Dal_Delivery_query("SELECT zone_id from {$table_prefix}ad_zone_assoc where zone_id =".$arow_sel_zone['zoneid']." AND ad_id=".$bannerid_get);

				if(OA_Dal_Delivery_numRows($query_select_zones_ass)==0)
				{  
					 if($banner_as_storage['storagetype']=='web' && $arow_sel_zone['delivery']=='0')
					 {
							$doZones_assoc = OA_Dal::factoryDO('ad_zone_assoc');
							$doZones_assoc->zone_id = $arow_sel_zone['zoneid'];
							$doZones_assoc->ad_id   = $bannerid_get;
							$doZones_assoc->priority= '0';
							$doZones_assoc->link_type   = '1';
							$doZones_assoc->priority_factor   = '1';
							$doZones_assoc->to_be_delivered   = '1';
							$doZones_assoc->insert();
					}
				
					if($banner_as_storage['storagetype']=='txt' && $arow_sel_zone['delivery']=='3')
					{
								$doZones_assoc = OA_Dal::factoryDO('ad_zone_assoc');
								$doZones_assoc->zone_id = $arow_sel_zone['zoneid'];
								$doZones_assoc->ad_id   = $bannerid_get;
								$doZones_assoc->priority= '0';
								$doZones_assoc->link_type   = '1';
								$doZones_assoc->priority_factor   = '1';
								$doZones_assoc->to_be_delivered   = '1';
								$doZones_assoc->insert();
					}
				}
		
			}
		} //exit;
	}
}
    foreach ($_POST['publisher'] as $val)
    {
        OA_Dal_Delivery_query("INSERT INTO djax_feed_network_publishers_assoc values('',$val,$id)") or die("error2");
    }
	
    $translated_message = $translation->translate("<b>".$_POST['netname']."</b> Account Has Been Set.");
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
    echo "<script>window.location = 'account-settings-feedlist.php';</script>";
    //OX_Admin_Redirect::redirect("account-settings-feedlist.php");   
}

//Select all publishers
$query = OA_Dal_Delivery_query("SELECT affiliateid,name FROM ".$table_prefix."affiliates") or die("error1");
while ($aRow = OA_Dal_Delivery_fetchAssoc($query))
{
    $aPublishers[$aRow['affiliateid']] = $aRow['name'];
}
$aPublishers = empty($aPublishers) ? "No Publishers available" : $aPublishers;

//Select all countries
$countries['']='---Select---';
$conquery = OA_Dal_Delivery_query("SELECT id,name,full_name FROM xml_shop_country") or die("error");
while ($cRow = OA_Dal_Delivery_fetchAssoc($conquery))
{
    $countries[$cRow['id']] = $cRow['full_name'];
}
$countries = empty($countries) ? "No Countries available" : $countries;

$category['']='---Select---';

$aSettings = array(
    array(
        'text' => 'Add a feed network',
        'items' => array(
            array(
                'type' => 'text',
                'text' => 'Network name',
                'name' => 'netname',
                'value' => '',
                'req' => true
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Network publisher id',
                'name' => 'npid',
                'value' => ''
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Network source id',
                'name' => 'nsid',
                'value' => ''
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Network Auth key ',
                'name' => 'nakey',
                'value' => ''
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Response url',
                'name' => 'resurl',
                'req' => true,
                'size' => '100',
                'check' => 'url',
                'value' => ''
            ) ,
            array(
                'type' => 'hidden',
                'text' => 'Report url',
                'name' => 'reurl',
                'size' => '100',
                'check' => 'url',
                'value' => ''
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'select',
                'text' => 'Map to a publisher',
                'name' => 'publisher[]',
                'req' => true,
                'items' => $aPublishers
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'select',
                'text' => 'Country',
                'name' => 'country',
                'items' => $countries
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'select',
                'text' => 'Category',
                'name' => 'category',
                'items' => $category
            )
        )
    )
);
$oOptions->show($aSettings);
?>
<script type='text/javascript'>
$("select[name='publisher[]']").attr('multiple','multiple');

var ccode;
$("#country").change(function(){
	if(this.value == 1) {
		ccode = 'au';
	} else if(this.value == 2) {
		ccode = 'es';
	} else if(this.value == 3) {
		ccode = 'ie';
	} else if(this.value == 4) {
		ccode = 'mx';
	} else if(this.value == 5) {
		ccode = 'us';
	} else if(this.value == 6) {
		ccode = 'uk';
	}
	
	getCategory(ccode);
  });
  
  function getCategory(code) {

	var xhttp = new XMLHttpRequest();
	xhttp.onreadystatechange = function() {
		if(this.readyState == 4 && this.status == 200) {
			document.getElementById("category").innerHTML = this.responseText;
		}
	};
	xhttp.open("GET","get_shop_categories.php?code=" + code, true);
	xhttp.send();
  }
</script>
<?php
phpAds_PageFooter();
?>
