<?php

require_once '../../../../init.php';
// Required files
require_once MAX_PATH.'/lib/OA/Admin/Option.php';
require_once MAX_PATH.'/lib/OA/Admin/Settings.php';
require_once MAX_PATH.'/lib/max/Plugin/Translation.php';
require_once MAX_PATH.'/lib/OX/Plugin/Component.php';
require_once MAX_PATH.'/www/admin/config.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
session_start();
// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
//Function to get the domain name
function url($url)
{
    $pu = parse_url($url);
    return $pu["scheme"]."://".$pu["host"];
}

//Select all publishers
$query = OA_Dal_Delivery_query("SELECT affiliateid,name FROM ".$table_prefix."affiliates") or die("error");
while ($aRow = OA_Dal_Delivery_fetchAssoc($query))
{
    $aPublishers[$aRow['affiliateid']] = $aRow['name'];
}
$aPublishers = empty($aPublishers) ? "No Publishers available" : $aPublishers;

//select all countries
$countries['']='---Select---';
$conquery = OA_Dal_Delivery_query("SELECT * FROM xml_shop_country") or die("error");
while ($cRow = OA_Dal_Delivery_fetchAssoc($conquery))
{
    $countries[$cRow['id']] = $cRow['full_name'];
}
$countries = empty($countries) ? "No Countries available" : $countries;

if (isset($_POST['submitok']) && $_POST['submitok'] == 'true')
{
    $translation = new OX_Translation();
    $_POST['re_url'] = url($_POST['reurl']);
    $_POST['res_url'] = url($_POST['resurl']);
    $date = date('Y-m-d');
    $time = date('Y-m-d H:i:s');
    $last_insert_advid = "";
    $last_insert_campid = "";
    $last_insert_bannerid = "";
    
    $all_banner_id = array();
  
    $map_pub=implode(",",array: $_POST['publisher']);
    
    //delete already linked zone
    $get_pub_qry = OA_Dal_Delivery_query("SELECT d.map_publisherid,a.bannerid FROM djax_feed_network as d
											join djax_all_network_feed as a on a.networkid = d.feed_network_id
											where d.feed_network_id=".$_POST['feedID']);
	while($get_publisher = OA_Dal_Delivery_fetchAssoc($get_pub_qry)) {
		$get_web_zones_qry = OA_Dal_Delivery_query("SELECT GROUP_CONCAT(zoneid) as zoneid FROM ".$table_prefix."zones where affiliateid in (".$get_publisher['map_publisherid'].")");
		$get_web_zones = OA_Dal_Delivery_fetchAssoc($get_web_zones_qry);
		$ad_Query = OA_Dal_Delivery_query("SELECT GROUP_CONCAT(ad_zone_assoc_id) as ad_zone_assoc_id FROM ".$table_prefix."ad_zone_assoc WHERE zone_id in (".$get_web_zones['zoneid'].") and ad_id in (".$get_publisher['bannerid'].") and link_type = 1") or die("error562");
		$adx_Row_res = OA_Dal_Delivery_fetchAssoc($ad_Query);
		if($adx_Row_res['ad_zone_assoc_id']) {
			   OA_Dal_Delivery_query("DELETE FROM ".$table_prefix."ad_zone_assoc WHERE ad_zone_assoc_id in (".$adx_Row_res['ad_zone_assoc_id'].") ") or die("error24545");
		}
	}
	   
	if (is_array($_POST['publisher'])) {
		// Convert the array to a string, if that's appropriate for your case
		// You might join the array elements with a delimiter like ','
		$publisherString = implode(',', $_POST['publisher']);
	} else {
		// Ensure it's a string, or handle it if it's not
		$publisherString = $_POST['publisher'];
	}
    $publisher_ID = explode(",", $publisherString);
    $all_banner_ids = array();
    foreach($publisher_ID as $pid)
	{
		$get_web_agency_qry = OA_Dal_Delivery_query("SELECT agencyid FROM ".$table_prefix."affiliates where affiliateid=".$pid);
		$get_web_agency = OA_Dal_Delivery_fetchAssoc($get_web_agency_qry);
				
		$get_client_qry = OA_Dal_Delivery_query("SELECT agencyid FROM ".$table_prefix."clients where agencyid=".$get_web_agency['agencyid']);
		$get_client = OA_Dal_Delivery_fetchAssoc($get_client_qry);
		$cli_count=OA_Dal_Delivery_numRows($get_client_qry);

		if($cli_count == 0) {
			$agencyId = $get_web_agency['agencyid'];
		
			//Add Account
			OA_Dal_Delivery_query("INSERT INTO {$table_prefix}accounts(
										account_type,
										account_name
										)
									 VALUES(
										'ADVERTISER',
										'".$_POST['netname']."_advertiser'
										)") or die("error");
			$last_insert_accountid = OA_Dal_Delivery_insertId();
			
			//For create advertiser
			$email = $_POST['netname'].'@xmlfeed.com';
			OA_Dal_Delivery_query("INSERT INTO {$table_prefix}clients(
										agencyid,
										clientname,
										contact,
										email,
										report,
										reportinterval,
										reportlastdate,
										reportdeactivate,
										comments,
										updated,
										account_id,
										advertiser_limitation,
										type)
									 VALUES(
										".$agencyId.",
										'".$_POST['netname']."_advertiser',
										'xmlfeed user',
										'".$email."',
										'f',
										'7',
										'',
										'',
										'',
										'".$time."',
										'".$last_insert_accountid."',
										'0',
										'0'
										)") or die("123");
			$last_insert_advid = OA_Dal_Delivery_insertId();
			
			   //create campaigns
			if ($last_insert_advid)
			{
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}campaigns(campaignname,clientid,views,clicks,conversions,
										priority,weight,target_impression,target_click,
										target_conversion,anonymous,companion,comments,
										revenue,revenue_type,
										updated,block,capping,session_capping,
										status,hosted_views,hosted_clicks,viewwindow,
										clickwindow,ecpm,min_impressions,ecpm_enabled,
										activate_time,type,show_capped_no_cookie
										)
									 VALUES(
										'".$_POST['netname']."_campaign','".$last_insert_advid."','-1','-1','-1','-1','1',
										'0',
										'0',
										'0',
										'f',
										'0',
										'',
										'','2','".$time."','0','0','0','0','0','0','0','0','','100','0','".$time."','0','0'
										)") or die("456");
				$last_insert_campid = OA_Dal_Delivery_insertId();
			}
			
			//for banner creation
			if ($last_insert_campid)
			{
				$last_insert_bannerid=[];
				$contenttype = 'jpeg';
				$storagetype = 'web';
				$desc = "".$_POST['netname']." native ad served in campaigns";
				$bannertype = "bannerTypeText:oxText:genericText";
				$native_type = "";
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','txt','0','txt','','','',
										 '',
										 '0',
										 '0',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 'https://www.google.com/','','text_banner','".$_POST['netname']." text ad served in campaigns','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','".$bannertype."','','0','1'
										 )") or die('789');
							$last_insert_bannerid[] = OA_Dal_Delivery_insertId();

				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','".$contenttype."','0','".$storagetype."','ef180efc30bd1d5e19837f8a46d687f5.jpg','','',
										 '',
										 '300',
										 '250',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 '','','','".$desc."','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','','','0','1'
										 )") or die('6767');
				$last_insert_bannerid[] = OA_Dal_Delivery_insertId();
				$last_insert_bannerid=implode(",",$last_insert_bannerid);
			}
			
			// insert all id's in the djax_all_network_feed table
			OA_Dal_Delivery_query("INSERT INTO djax_all_network_feed(
								networkid,
								agencyid,
								clientid,
								campaignid,
								bannerid
								)
							 VALUES(
								'".$_POST['feedID']."',
								'".$agencyId."',
								'".$last_insert_advid."',
								'".$last_insert_campid."',
								'".$last_insert_bannerid."'
									)") or die("insertnew");
				array_push($all_banner_id,$last_insert_bannerid);
			
		}
				
        $query_sel_zone = OA_Dal_Delivery_query("SELECT zoneid,delivery FROM ".$table_prefix."zones where affiliateid=".$pid);
        $zone_count=OA_Dal_Delivery_numRows($query_sel_zone);
        if($zone_count>0)
        {
		  while ($arow_sel_zone = OA_Dal_Delivery_fetchAssoc($query_sel_zone))
			{
				$query_sel_banners1 = OA_Dal_Delivery_query("SELECT bannerid FROM djax_all_network_feed where networkid=".$_POST['feedID']." and agencyid =".$get_web_agency['agencyid']);
				$query_sel_banners=OA_Dal_Delivery_fetchAssoc($query_sel_banners1);
				
				/*while($query_sel_banners=OA_Dal_Delivery_fetchAssoc($query_sel_banners1)) {
					array_push($all_banner_ids,$query_sel_banners['bannerid']);
				}
				$all_ban_id = implode(',',$all_banner_ids); */

				$last_insert_bannerid_exp=explode(",",$query_sel_banners['bannerid']);

				foreach($last_insert_bannerid_exp as $bannerid_get)
				{
                
					$banner_as_storage1 = OA_Dal_Delivery_query("SELECT storagetype from {$table_prefix}banners where bannerid=".$bannerid_get);
					$banner_as_storage = OA_Dal_Delivery_fetchAssoc($banner_as_storage1);
					$query_select_zones_ass = OA_Dal_Delivery_query("SELECT zone_id from {$table_prefix}ad_zone_assoc where zone_id =".$arow_sel_zone['zoneid']." AND ad_id=".$bannerid_get);
		
          
					if(OA_Dal_Delivery_numRows($query_select_zones_ass)==0)
					{  
						 if($banner_as_storage['storagetype']=='web' && $arow_sel_zone['delivery']=='0')
						 {
							$doZones_assoc = OA_Dal::factoryDO('ad_zone_assoc');
							$doZones_assoc->zone_id = $arow_sel_zone['zoneid'];
							$doZones_assoc->ad_id   = $bannerid_get;
							$doZones_assoc->priority= '0';
							$doZones_assoc->link_type   = '1';
							$doZones_assoc->priority_factor   = '1';
							$doZones_assoc->to_be_delivered   = '1';
							$doZones_assoc->insert();
						}
			
						if($banner_as_storage['storagetype']=='txt' && $arow_sel_zone['delivery']=='3')
						{
							$doZones_assoc = OA_Dal::factoryDO('ad_zone_assoc');
							$doZones_assoc->zone_id = $arow_sel_zone['zoneid'];
							$doZones_assoc->ad_id   = $bannerid_get;
							$doZones_assoc->priority= '0';
							$doZones_assoc->link_type   = '1';
							$doZones_assoc->priority_factor   = '1';
							$doZones_assoc->to_be_delivered   = '1';
							$doZones_assoc->insert();
						}
					}
        
				}
        }
	}
}
   
    
    OA_Dal_Delivery_query("UPDATE djax_feed_network SET
								feed_network_name 		= '".$_POST['netname']."',
								publisher_id 			= '".$_POST['npid']."',
								source_id 			= '".$_POST['nsid']."',
								auth_key 			= '".$_POST['nakey']."',
								feed_network_ads_url 		= '".$_POST['resurl']."',
								feed_network_report_url 	= '".$_POST['reurl']."',
								feed_network_ads_base_url 	= '".$_POST['res_url']."',
								feed_network_report_base_url 	= '".$_POST['re_url']."',
                                map_publisherid 	= '".$map_pub."'
								WHERE feed_network_id		= '".$_POST['feedID']."'");
	// Now you can safely use explode
	$publisher_ID = explode(",", $publisherString);    
    OA_Dal_Delivery_query("DELETE FROM djax_feed_network_publishers_assoc WHERE feed_network_id='".$_POST['feedID']."' ") or die("error2");
    foreach ($_POST['publisher'] as $val)
    {
        OA_Dal_Delivery_query("INSERT INTO djax_feed_network_publishers_assoc values('',$val,".$_POST['feedID'].")") or die("error1");
    }
    
    //update country in client table
    $adx_Query = OA_Dal_Delivery_query("SELECT * FROM djax_all_network_feed WHERE networkid='".$_POST['feedID']."'") or die("error56");
    while($adx_Row = OA_Dal_Delivery_fetchAssoc($adx_Query)) {
		OA_Dal_Delivery_query("UPDATE ".$table_prefix."clients SET
								shop_country = '".$_POST['country']."'
								WHERE clientid	= '".$adx_Row['clientid']."'");
	}
    
    $translated_message = $translation->translate("<b>".$_POST['netname']."</b> has been updated.");
   
    header('Location:account-settings-feedlist.php');

}

$aErrormessage = array();
$oOptions = new OA_Admin_Option('settings');
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel("Xmlfeed Network Edit");
phpAds_PageHeader('account-settings-feedlist', $oHeaderModel);
$map = array();
if (!empty($_GET['netid']))
{
    $adx_Query = OA_Dal_Delivery_query("SELECT * FROM djax_feed_network WHERE feed_network_id='".$_GET['netid']."'") or die("error56");
    $adx_Row = OA_Dal_Delivery_fetchAssoc($adx_Query);
    $Query = OA_Dal_Delivery_query("SELECT * FROM djax_feed_network_publishers_assoc WHERE feed_network_id='".$_GET['netid']."'") or die("error34");
    while ($Row = OA_Dal_Delivery_fetchAssoc($Query))
    {
        $affiliate[$Row['publisher_affilate_id']] = $Row['publisher_affilate_id'];
    }
 
    $cli_Query = OA_Dal_Delivery_query("SELECT shop_country FROM ".$table_prefix."clients WHERE clientid='".$adx_Row['clientid']."'") or die("error1");
    $cli_Row = OA_Dal_Delivery_fetchAssoc($cli_Query);
    $cQuery = OA_Dal_Delivery_query("SELECT * FROM xml_shop_country WHERE id='".$adx_Row['shop_country_id']."'") or die("error2");
    
    while ($cRow = OA_Dal_Delivery_fetchAssoc($cQuery))
    {
        $selCountry[$cRow['id']] = $cRow['full_name'];
        $selCountry1[$cRow['id']] = $cRow['name'];
    }
    
    $catQuery = OA_Dal_Delivery_query("SELECT * FROM xml_shop_country WHERE id='".$adx_Row['shop_category_id']."'") or die("error2");
    $catRow = OA_Dal_Delivery_fetchAssoc($catQuery);
    
    $category['']='---Select---';
    
    $selcategory = $adx_Row['shop_category_id'];
    $passCountry = $selCountry1[$adx_Row['shop_country_id']];
    
    
    $aSettings = array(
        array(
            'text' => 'Add a feed network',
            'items' => array(
                array(
                    'type' => 'text',
                    'text' => 'Network name',
                    'name' => 'netname',
                    'value' => $adx_Row['feed_network_name'],
                    'req' => true
                ) ,
                array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'text',
                    'text' => 'Network publisher id',
                    'name' => 'npid',
                    'value' => $adx_Row['publisher_id']
                ) ,
                array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'text',
                    'text' => 'Network source id',
                    'name' => 'nsid',
                    'value' => $adx_Row['source_id'],
                ) ,
                array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'text',
                    'text' => 'Network Auth key ',
                    'name' => 'nakey',
                    'value' => $adx_Row['auth_key'],
                ) ,
                array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'text',
                    'text' => 'Response url',
                    'name' => 'resurl',
                    'req' => true,
                    'check' => 'url',
                    'size' => '100',
                    'value' => $adx_Row['feed_network_ads_url'],
                ) ,
                array(
                    'type' => 'hidden',
                    'text' => 'Report url',
                    'name' => 'reurl',
                    'check' => 'url',
                    'value' => $adx_Row['feed_network_report_url'],
                ) ,
                array(
                    'type' => 'hiddenfield',
                    'text' => 'feedID',
                    'name' => 'feedID',
                    'value' => $_GET['netid'],
                ) ,
                array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'select',
                    'text' => 'Map to a publisher',
                    'name' => 'publisher[]',
                    'req' => true,
                    'items' => $aPublishers,
                    'value' => $affiliate
                ),
                 array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'select',
                    'text' => 'Country',
                    'name' => 'country',
                    'items' => $countries,
                    'value' => $selCountry
                ) ,
                 array(
                    'type' => 'break'
                ) ,
                array(
                    'type' => 'select',
                    'text' => 'Category',
                    'name' => 'category',
                    'items' => $category,
                    'value' => $selcategory
                ) ,
            )
        )
    );
    $oOptions->show($aSettings);
?>
<script type='text/javascript'>

$("select[name='publisher[]']").attr('multiple','multiple');
var ccode;
				
$("#country").change(function() {
	if(this.value == 1) {
		ccode = 'au';
	} else if(this.value == 2) {
		ccode = 'es';
	} else if(this.value == 3) {
		ccode = 'ie';
	} else if(this.value == 4) {
		ccode = 'mx';
	} else if(this.value == 5) {
		ccode = 'us';
	} else if(this.value == 6) {
		ccode = 'uk';
	}
	
	getCategory(ccode);
});
  
var code = "<?php echo $passCountry; ?>";
getCategoryselesct(code)
  
function getCategoryselesct(code) {
	var selC = "<?php echo $selcategory; ?>";

	var xhttp = new XMLHttpRequest();
	xhttp.onreadystatechange = function() {
		if(this.readyState == 4 && this.status == 200) {
			document.getElementById("category").innerHTML = this.responseText;
		}
	};
	xhttp.open("GET","get_shop_categories.php?code=" + code+"&selC="+selC, true);
	xhttp.send();
}
  
function getCategory(code) {			

	var xhttp = new XMLHttpRequest();
	xhttp.onreadystatechange = function() {
	if(this.readyState == 4 && this.status == 200) {
		document.getElementById("category").innerHTML = this.responseText;
	}
	};
	xhttp.open("GET","get_shop_categories.php?code=" + code, true);
	xhttp.send();
}
</script>
<?php
}
else
{
    $translation = new OX_Translation();
    OX_Admin_Redirect::redirect("account-settings-feedlist.php");
}
phpAds_PageFooter();
?>
