<?php

require_once LIB_PATH . '/Extension/deliveryLimitations/DeliveryLimitationsCommaSeparatedData.php';
require_once MAX_PATH . '/lib/max/Delivery/limitations.delivery.php';

class Plugins_DeliveryLimitations_Client_Keywords extends Plugins_DeliveryLimitations_CommaSeparatedData
{
    function __construct()
    {
        parent::__construct();
        $this->nameEnglish = 'Client - Keyword-Target';
        $this->aOperations = array(
            '=x' => MAX_Plugin_Translation::translate('Pharse Match', $this->extension, $this->group),
            '!x' => MAX_Plugin_Translation::translate('Not Pharse Match', $this->extension, $this->group));
    }
    function displayArrayData()
    {
		$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

		$query=OA_Dal_Delivery_query("select * from djax_feed_keywordlist");
		
		while($results=OA_Dal_Delivery_fetchAssoc($query))
		{
			$res[$results['keyword']]=$results['keyword'];
		}
		$djaxdata=$this->data;	
		$newkeywords=array();$keyword=array();
		foreach($djaxdata as $keyid => $value)
		{
			$tkeyword=explode('|',$value);
			$newkeywords[$tkeyword[0]]=$tkeyword[1];
			$keyword[]=$tkeyword[0];
		}
        $tabindex =& $GLOBALS['tabindex'];
        echo "<div class='box'>";
        foreach ($res as $code => $name)
		{
			$bidamt=$newkeywords[$code];
            echo "<div class='boxrow'>";
            echo "<input tabindex='".($tabindex++)."' ";
            echo "type='checkbox' id='c_{$this->executionorder}_{$code}' name='acl[{$this->executionorder}][data][]' value='{$code}'".(in_array($code, $keyword) ? ' CHECKED' : '').">{$name}";
            // echo "<input type='text' id='bid_{$this->executionorder}_{$code}' name='acl[{$this->executionorder}][data][][]' value='$bidamt' >";
            echo "</div>";
        }
        echo "</div>";
    }
}

?>
