<?php

$path = dirname(__FILE__);
require_once $path . '/../../../../init.php';

require_once MAX_PATH . '/lib/OA/Dal.php';
require_once MAX_PATH . '/www/admin/config.php';

if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

$date = date('Y-m-d');
$time = date('Y-m-d H:i:s');
$last_insert_advid = "";
$last_insert_campid = "";
$last_insert_bannerid = "";

$all_agency_query = OA_Dal_Delivery_query("SELECT group_concat(distinct agencyid) as agencyid FROM djax_all_network_feed");
$getData = OA_Dal_Delivery_fetchAssoc($all_agency_query);

$get_agency_query = OA_Dal_Delivery_query("SELECT agencyid from {$table_prefix}agency where agencyid not in (".$getData['agencyid'].") and status = 0");

while($newagency = OA_Dal_Delivery_fetchAssoc($get_agency_query)) {
	$all_feed_qry = OA_Dal_Delivery_query("SELECT * FROM djax_feed_network where status = 0");
	while($all_feedres = OA_Dal_Delivery_fetchAssoc($all_feed_qry)) {
		$agencyId = $newagency['agencyid'];
		$id = $all_feedres['feed_network_id'];

		//Add Account
		OA_Dal_Delivery_query("INSERT INTO {$table_prefix}accounts(
									account_type,
									account_name
									)
								 VALUES(
									'ADVERTISER',
									'".$all_feedres['feed_network_name']."_advertiser'
									)") or die("error");
		$last_insert_accountid = OA_Dal_Delivery_insertId();
		
		//For create advertiser
		$email = $all_feedres['feed_network_name'].'@xmlfeed.com';
		OA_Dal_Delivery_query("INSERT INTO {$table_prefix}clients(
									agencyid,
									clientname,
									contact,
									email,
									report,
									reportinterval,
									reportlastdate,
									reportdeactivate,
									comments,
									updated,
									account_id,
									advertiser_limitation,
									type)
								 VALUES(
									".$agencyId.",
									'".$all_feedres['feed_network_name']."_advertiser',
									'xmlfeed user',
									'".$email."',
									'f',
									'7',
									'',
									'',
									'',
									'".$time."',
									'".$last_insert_accountid."',
									'0',
									'0'
									)") or die("");
		$last_insert_advid = OA_Dal_Delivery_insertId();
		
		   //create campaigns
			if ($last_insert_advid)
			{
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}campaigns(campaignname,clientid,views,clicks,conversions,
										priority,weight,target_impression,target_click,
										target_conversion,anonymous,companion,comments,
										revenue,revenue_type,
										updated,block,capping,session_capping,
										status,hosted_views,hosted_clicks,viewwindow,
										clickwindow,ecpm,min_impressions,ecpm_enabled,
										activate_time,type,show_capped_no_cookie
										)
									 VALUES(
										'".$all_feedres['feed_network_name']."_campaign','".$last_insert_advid."','-1','-1','-1','-1','1',
										'0',
										'0',
										'0',
										'f',
										'0',
										'',
										'','2','".$time."','0','0','0','0','0','0','0','0','','100','0','".$time."','0','0'
										)") or die("");
				$last_insert_campid = OA_Dal_Delivery_insertId();
			}
			 
			//for banner creation
			if ($last_insert_campid)
			{
				$last_insert_bannerid=[];
				$contenttype = 'jpeg';
				$storagetype = 'web';
				$desc = "".$_POST['netname']." native ad served in campaigns";
				$bannertype = "bannerTypeText:oxText:genericText";
				$native_type = "";
				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','txt','0','txt','','','',
										 '',
										 '0',
										 '0',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 'https://www.google.com/','','text_banner','".$all_feedres['feed_network_name']." text ad served in campaigns','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','".$bannertype."','','0','1'
										 )") or die('');
							$last_insert_bannerid[] = OA_Dal_Delivery_insertId();

				OA_Dal_Delivery_query("INSERT INTO {$table_prefix}banners(campaignid,contenttype,pluginversion,storagetype,filename,
										 imageurl,htmltemplate,htmlcache,width,height,weight,seq,target,
										 url,alt,statustext,bannertext,description,adserver,block,capping,
										 session_capping,compiledlimitation,acl_plugins,append,bannertype,
										 alt_filename,alt_imageurl,alt_contenttype,comments,updated,
										 acls_updated,keyword,transparent,parameters,status,ext_bannertype,
										 prepend,iframe_friendly,is_feed
										)
									 VALUES(
										 '".$last_insert_campid."','".$contenttype."','0','".$storagetype."','ef180efc30bd1d5e19837f8a46d687f5.jpg','','',
										 '',
										 '300',
										 '250',
										 '1',
										 '0','',
										 'https://www.google.com/',
										 '','','','".$desc."','','0','0','0','','','','0','','','gif','','".$time."','','','0','','0','','','0','1'
										 )") or die('');
				$last_insert_bannerid[] = OA_Dal_Delivery_insertId();
				$last_insert_bannerid=implode(",",$last_insert_bannerid);
			}
			
			// insert all id's in the djax_all_network_feed table
			OA_Dal_Delivery_query("INSERT INTO djax_all_network_feed(
								networkid,
								agencyid,
								clientid,
								campaignid,
								bannerid
								)
							 VALUES(
								'".$id."',
								'".$agencyId."',
								'".$last_insert_advid."',
								'".$last_insert_campid."',
								'".$last_insert_bannerid."'
									)") or die("insertnew");
				//array_push($all_banner_id,$last_insert_bannerid);
	}
}



		

