<?php
// Require the initialisation file
require_once '../../../../init.php';
// Required files
require_once MAX_PATH.'/lib/OA/Dal.php';
require_once MAX_PATH.'/www/admin/config.php';
require_once MAX_PATH.'/www/admin/lib-storage.inc.php';
require_once MAX_PATH.'/www/admin/lib-zones.inc.php';
require_once MAX_PATH.'/www/admin/lib-statistics.inc.php';
require_once MAX_PATH.'/lib/OA/Maintenance/Priority.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

// Register input variables
phpAds_registerGlobal('returnurl');
/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/
if (!empty($_GET['netid']))
{
    $action = ($_GET['action'] == "enable") ? 0 : 1;
    OA_Dal_Delivery_query("UPDATE djax_feed_network SET status = $action WHERE feed_network_id in (".$_GET['netid'].")") or die("error");
    // Queue confirmation message
    $translation = new OX_Translation();
    if ($action)
    {
        $translated_message = $translation->translate('Feed Network has been blocked');
    }
    else
    {
        $translated_message = $translation->translate('Feed Network has been Un-Blocked');
    }
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
}
if (empty($returnurl))
{
    $returnurl = 'account-settings-feedlist.php';
}
header("Location: ".$returnurl);
?>
