<?php

// Require the initialisation file
require_once '../../../../init.php';
// Required files
require_once MAX_PATH.'/lib/OA/Dal.php';
require_once MAX_PATH.'/www/admin/config.php';
require_once MAX_PATH.'/www/admin/lib-storage.inc.php';
require_once MAX_PATH.'/www/admin/lib-zones.inc.php';
require_once MAX_PATH.'/www/admin/lib-statistics.inc.php';
require_once MAX_PATH.'/lib/OA/Maintenance/Priority.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

// Register input variables
phpAds_registerGlobal('returnurl');
/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/
if (!empty($_GET['netid']))
{
   
    $all_data_qry = OA_Dal_Delivery_query("SELECT networkid,clientid,campaignid,bannerid from djax_all_network_feed where networkid =".$_GET['netid']);
    while($row_net = OA_Dal_Delivery_fetchAssoc($all_data_qry)){
				
		$bannerid=$row_net['bannerid'];
		
		$query_select_ban_check = OA_Dal_Delivery_query("SELECT bannerid from {$table_prefix}banners where bannerid in ($bannerid)");
						
		$query_select_ban_row=OA_Dal_Delivery_numRows($query_select_ban_check);
		
		if($query_select_ban_row > 0)
		{  
			OA_Dal_Delivery_query("DELETE from {$table_prefix}banners where bannerid in ($bannerid)");
		}   
		
		OA_Dal_Delivery_query("DELETE from {$table_prefix}campaigns where campaignid =".$row_net['campaignid']);
		
		OA_Dal_Delivery_query("DELETE from {$table_prefix}clients where clientid =".$row_net['clientid']);
		
		OA_Dal_Delivery_query("DELETE FROM djax_all_network_feed WHERE networkid=".$_GET['netid']);
		
		
	}
    
    $query_select_net = OA_Dal_Delivery_query("SELECT map_publisherid from djax_feed_network where feed_network_id =".$_GET['netid']);
    $row_net_pub = OA_Dal_Delivery_fetchAssoc($query_select_net);
    $pub_exp=explode(",",$row_net_pub['map_publisherid']);


    //check any zones available
   foreach($pub_exp as $publisherid)
   {
    $query_select_zones = OA_Dal_Delivery_query("SELECT zoneid from {$table_prefix}zones where affiliateid =".$publisherid);
     $zone_count=OA_Dal_Delivery_numRows($query_select_zones);
     if($zone_count>0)
     {
		while($row_zones = OA_Dal_Delivery_fetchAssoc($query_select_zones))
		{
		  
			$query_select_zones_ass = OA_Dal_Delivery_query("SELECT zone_id from {$table_prefix}ad_zone_assoc where zone_id =".$row_zones['zoneid']);

			$zone_count_ass=OA_Dal_Delivery_numRows($query_select_zones_ass);
			if($zone_count_ass>0)
			{  
				 OA_Dal_Delivery_query("delete from {$table_prefix}ad_zone_assoc where zone_id=".$row_zones['zoneid']);
			}
			
		}
    }
    
    OA_Dal_Delivery_query("DELETE FROM djax_feed_network_publishers_assoc WHERE publisher_affilate_id=".$publisherid." AND feed_network_id=".$_GET['netid']); 
 
   }
   
   	OA_Dal_Delivery_query("DELETE FROM djax_feed_network WHERE feed_network_id =".$_GET['netid']);

   
    // Queue confirmation message
    $translation = new OX_Translation();
    $translated_message = $translation->translate('Feed Network has been deleted');
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
}
if (empty($returnurl))
{
    $returnurl = 'account-settings-feedlist.php';
}
header("Location: ".$returnurl);
?>
