<?php

require_once '../../../../init.php';
require_once MAX_PATH.'/lib/OA/Admin/Option.php';
require_once MAX_PATH.'/lib/OA/Admin/Settings.php';
require_once MAX_PATH.'/lib/max/Plugin/Translation.php';
require_once MAX_PATH.'/lib/OX/Plugin/Component.php';
require_once MAX_PATH.'/www/admin/config.php';
if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);
if (isset($_POST['submitok']) && $_POST['submitok'] == 'true')
{
    $selectfeed = OA_Dal_Delivery_query("select * from djax_feed_network_limitations where feed_network_id='".$_REQUEST['netid']."'");
    if (OA_Dal_Delivery_numRows($selectfeed) > 0)
    {
        OA_Dal_Delivery_query("UPDATE `djax_feed_network_limitations` SET 
									`network_max_req_day`='".$_POST['areq']."',
									`network_max_click_day`='".$_POST['acl']."', 
									`network_max_click_ad`='".$_POST['cklimit']."', 
									`network_max_click_keyword`='".$_POST['selimit']."', 
									`network_max_click_ip`='".$_POST['iplimit']."', 
									`network_min_ctr`='".$_POST['minctr']."', 
									`network_max_ctr`='".$_POST['maxctr']."'
									WHERE feed_network_id='".$_POST['netid']."'");
    }
    else
    {
        OA_Dal_Delivery_query("INSERT INTO `djax_feed_network_limitations` 
									(
									`feed_network_id`,
									`network_max_req_day`, 
									`network_max_click_day`, 
									`network_max_click_ad`, 
									`network_max_click_keyword`, 
									`network_max_click_ip`, 
									`network_min_ctr`, 
									`network_max_ctr`)
									VALUES(
									'".$_POST['netid']."',
									'".$_POST['areq']."',
									'".$_POST['acl']."',
									'".$_POST['cklimit']."',
									'".$_POST['selimit']."',
									'".$_POST['iplimit']."',
									'".$_POST['minctr']."',
									'".$_POST['maxctr']."')") or die("error");
    }
    $translation = new OX_Translation();
    $translated_message = $translation->translate("<b>Feed network</b>limitations updated.");
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
    OX_Admin_Redirect::redirect("plugins/XmlFeedNetwork/account-settings-feedlist.php");
}
$aErrormessage = array();
$oOptions = new OA_Admin_Option('settings');
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel("Feed network Limitations");
phpAds_PageHeader('account-settings-feedlist', $oHeaderModel);
$map = array();
if (!empty($_GET['netid']))
{
    $adx_Query = OA_Dal_Delivery_query("SELECT * FROM djax_feed_network_limitations WHERE feed_network_id='".$_GET['netid']."'") or die("error");
    $adx_Row = OA_Dal_Delivery_fetchAssoc($adx_Query);
}
$aSettings = array(
    array(
        'text' => 'Feed network configuration',
        'items' => array(
            array(
                'type' => 'text',
                'text' => ' Average Requests per Day',
                'name' => 'areq',
                'value' => $adx_Row['network_max_req_day'],
                //'req' => true
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Average Clicks per Day',
                'name' => 'acl',
                'value' => $adx_Row['network_max_click_day'],
                //'req' => true
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Min CTR (%)',
                'name' => 'minctr',
                'value' => $adx_Row['network_min_ctr'],
                //'req' => true,
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Max CTR (%) ',
                'value' => $adx_Row['network_max_ctr'],
                'name' => 'maxctr',
                //'req' => true,
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Total Clicks Limit per Search',
                'name' => 'selimit',
                //'req' => true,
                'value' => $adx_Row['network_max_click_keyword'],
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'text',
                'text' => 'Total Clicks Limit per IP',
                'name' => 'iplimit',
                //'req' => true,
                'value' => $adx_Row['network_max_click_ip'],
            ) ,
            array(
                'type' => 'break'
            ) ,
            array(
                'type' => 'hiddenfield',
                'text' => 'netid',
                'name' => 'netid',
                'value' => $_GET['netid'],
            ) ,
        )
    )
);
$oOptions->show($aSettings);
phpAds_PageFooter();
?>
